Index: kern_clock.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_clock.c,v
retrieving revision 1.102
diff -u -p -r1.102 kern_clock.c
--- kern_clock.c	13 Jan 2021 16:28:49 -0000	1.102
+++ kern_clock.c	2 Nov 2021 19:13:29 -0000
@@ -163,11 +163,26 @@ hardclock(struct clockframe *frame)
 	/*
 	 * If no separate statistics clock is available, run it from here.
 	 */
+#if defined(MULTIPROCESSOR)
+	// neirac:
+	// don't schedule on an idle cpu or one
+	// that has only one runnable task.
+	
+	if (((!cpu_is_idle(ci)) || (ci->ci_schedstate.spc_nrun > 1))
+			&& (stathz == 0)) 
+		statclock(frame);
+
+	if (--ci->ci_schedstate.spc_rrticks <= 0 && 
+			((!cpu_is_idle(ci)) ||
+			(ci->ci_schedstate.spc_nrun > 1)))
+		roundrobin(ci);
+#else
 	if (stathz == 0)
 		statclock(frame);
 
 	if (--ci->ci_schedstate.spc_rrticks <= 0)
 		roundrobin(ci);
+#endif
 
 #if NDT > 0
 	DT_ENTER(profile, NULL);
